﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Web.Security;

public partial class _Default : System.Web.UI.Page 
{
    private bool loggedIn = false;
    private bool loginFailed = false;
    private int userid;
    private string username;
    private string displayName;
    private string email;
    private bool showEmail;
    private DateTime createDate;
    private int accessLevel;

    public enum var
    {
        GET, POST, SESSION, COOKIE
    }
    public enum clean{
        DB
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        authenticate();

        string content = null;
        content += header();
        content += layout();
        
        if (getVariable("logon", var.GET) == "true" || loginFailed)
        {
            content += showLogon();
        }
        else
        {
            content += showBlogs();
        }
        content += footer();
        Response.Write(content);
    }
    private string header()
    {
        string content = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"" +
             "\"http://www.w3.org/TR/html4/strict.dtd\">" +
         @"<html>
        <head>
            <title>cSharp Blog</title>
            <link rel='stylesheet' type='text/css' href='style.css'>
        </head>
        <body>";
        return content;
    }
    private string layout()
    {
        string content = @"            <center><img src='header.png'></center>
            <div class='rightBar'>
                <div class='title'>C# Blog Menu</div>
                <ul>
                    <li>";
        content += (loggedIn) ? "<a href='default.aspx?logon=false'>Log Out</a>" : "<a href='default.aspx?logon=true'>Log In </a>";            
        content += "</li>";
        if (loggedIn && accessLevel == 255)
        {
            content += @"<li><a href=''>Create Account</a></li>
                        <li><a href=''>Write Blog Entry</a></li>
                        <li><a href=''>See New Entries</a></li>";
        }
        content += @"</ul>
            </div>";
        return content;
    }
    private string showLogon()
    {
        string content = @"<center><div class='login'>
            <form method='POST' action='default.aspx'>
                Username: <input name='username'><br>
                Password: <input name='password' type='password'><br>
                <div class='button'><input type='submit' value='Log In'></div>";
        if (loginFailed)
        {
            content += "<div class='error'>The username/password combination is invalid</div>";
        }
        content += @"</form>
        </div></center>";

        return content;
    }
    private string showBlogs()
    {
        string content = null;
        string select = "SELECT top 30 blogID, blogTitle, blogText, displayName, displayDate, " +
	        "CASE " +
		        "WHEN showEmail = 1 THEN ' (<a href=\"mailto: ' + email + '\">' + email + '</a>)' " +
		        "ELSE '' " +
	        "END AS 'email', " +
               "(SELECT COUNT(*) FROM comments WHERE blogID=a.blogID and visible=1) as Comments " +
        "FROM blogs a " +
	        "JOIN users b on " +
		        "a.userID=b.userID " +
        "ORDER BY displayDate Desc";

        SqlDataReader dr = query(select);
        while (dr.Read())
        {
            content += @"<div class='blogEntry'>
            <div class='blogTitle'>
                <div class='title'>" + dr["blogTitle"] + @"</div>
                <div class='commands'><a href=''>Edit</a> / <a href=''>Delete</a></div>
            </div>
            <div class='blogSubTitle'>
                <div class='author'>By " + dr["displayName"] + dr["email"] + @"</div>
                <div class='date'>" + Convert.ToDateTime(dr["displayDate"]).ToString("dd MMM yyyy") + @"</div>
            </div>
            <div class='text'>" + Convert.ToString(dr["blogText"]).Replace("\n", "<br>") + @"</div>
            <div class='comments'><a href=''>Comments (" + dr["Comments"] + @") </a></div>
        </div>";
        }
        dr.Dispose();
        return content;
    }
    private string footer()
    {
        string content = "</body></html>";
        return content;
    }

    private void authenticate()
    {
        string _username = null, password = null;
        if (getVariable("logon", var.GET) == "false")
        {
            cookie(false, null);
            return;
        }
        if (getVariable("username", var.POST) != null && getVariable("password", var.POST) != null)
        {   //check for POST vars from the login form
            _username = sanitize(getVariable("username", var.POST), clean.DB);
            password = FormsAuthentication.HashPasswordForStoringInConfigFile(getVariable("password", var.POST), "MD5");
        }
        else if (Session["blogUsername"] != null && Session["blogPassword"] != null)
        {   //check for sessions
            _username = sanitize(Session["blogUsername"].ToString(), clean.DB);
            password = sanitize(Session["blogPAssword"].ToString(), clean.DB);
        }
        else
        {   //check for cookies
            HttpCookie usernameCookie = HttpContext.Current.Request.Cookies["blogUsername"];
            HttpCookie passwordCookie = HttpContext.Current.Request.Cookies["blogPassword"];
            if (usernameCookie != null && passwordCookie != null)
            {
                _username = sanitize(usernameCookie.Value, clean.DB);
                password = sanitize(passwordCookie.Value, clean.DB);
            }
        }

        if (_username == null || password == null)
        {
            return;
        }

        string select = "SELECT userid, username, displayName, email, showEmail, createDate, accessLevel " + 
            "FROM users WHERE username='" + _username + "' AND password='" + password + "'";
        SqlDataReader dr = query(select);
        if (dr.HasRows)
        {
            dr.Read();
            loggedIn = true;
            userid = Convert.ToInt16(dr["userid"]);
            username = Convert.ToString(dr["username"]);
            displayName = Convert.ToString(dr["displayName"]);
            email = Convert.ToString(dr["email"]);
            showEmail = (Convert.ToInt16(dr["showEmail"]) == 1) ? true : false;
            createDate = Convert.ToDateTime(dr["createDate"]);
            accessLevel = Convert.ToInt16(dr["accessLevel"]);
            cookie(true, password); //set cookies and sessions
        }
        else
        {
            loggedIn = false;
            if (getVariable("username", var.POST) != null && getVariable("password", var.POST) != null)
            {
                loginFailed = true; //remove any sessions or cookies
            }
            cookie(false, null);
        }
        dr.Dispose();        
    }
    private void cookie(bool set, string password)
    {
        HttpCookie usernameCookie = new HttpCookie("blogUsername");
        HttpCookie passwordCookie = new HttpCookie("blogPassword");
        switch (set)
        {
            case true:
                //set cookies
                usernameCookie.Value = username;
                passwordCookie.Value = password;
                usernameCookie.Expires = System.DateTime.Now.AddHours(24);
                passwordCookie.Expires = System.DateTime.Now.AddHours(24);
                HttpContext.Current.Response.Cookies.Add(usernameCookie);
                HttpContext.Current.Response.Cookies.Add(passwordCookie);

                //set sessions
                Session["blogUsername"] = username;
                Session["blogPassword"] = password;
                break;
            case false:
                //set cookies to expire yesterday
                usernameCookie = HttpContext.Current.Request.Cookies["blogUsername"];
                passwordCookie = HttpContext.Current.Request.Cookies["blogPassword"];
                try
                {
                    usernameCookie.Expires = DateTime.Now.AddDays(-1);
                    HttpContext.Current.Response.Cookies.Add(usernameCookie);
                }
                catch { }
                try
                {
                    passwordCookie.Expires = DateTime.Now.AddDays(-1);
                    HttpContext.Current.Response.Cookies.Add(passwordCookie);
                }
                catch { }

                //kill sessions
                Session.Abandon();
                break;
        }
    }
    private SqlDataReader query(string select)
    {
        SqlConnection conn = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["blogDatabase"].ConnectionString);
        conn.Open();
        SqlCommand cm = new SqlCommand(select, conn);
        return cm.ExecuteReader();
    }
    private string getVariable(string input, var varType)
    {
        string variable = null;
        switch (varType)
        {
            case var.GET:
                try
                {
                    int doesVarExist = Request.QueryString[input].Length;
                    variable = Request.QueryString[input];
                }
                catch { }
                break;
            case var.POST:
                try
                {
                    if (Request.Form.Get(input).Length > 0)
                    {
                        variable = Request.Form.Get(input);
                    }
                }
                catch { }
                break;
        }
        
        return variable;
    }
    private string sanitize(string value, clean type)
    {
        switch (type)
        {
            case clean.DB:
                value = value.Replace("'", "''");
                break;
        }

        return value;
    }

}
